<?
sapp_include_once('common.php');



function form_handler()
{
    $valid = true;

    // check ssl

        $ssl = sapp_get_submit_value('ssl');
    switch ($ssl) {
        case 'true':
            sapp_set_ssl(true);
            sapp_set_param('ssl','https');
            break;

        default:
            sapp_set_ssl(false);
            sapp_set_param('ssl','http');
            break;
    }


    // check install_prefix

        $install_prefix = sapp_get_submit_value('install_prefix');

    if (in_array($install_prefix, array(".", "/", "./")))
    {
        $ret = (function_exists('sapp_check_install_prefix'))? sapp_check_install_prefix(SITEAPP_PREFIX_ROOT) : false;
        if (false === $ret || !in_array($ret, array(SITEAPP_DIR_NOT_EXISTS, SITEAPP_DIR_USED_BY_UNKNOWN)))
        {
            sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
            $valid = false;
        }
    }

    switch (sapp_set_install_prefix($install_prefix)) {

        case SITEAPP_DIR_NOT_EXISTS:
            break;

        case SITEAPP_DIR_USED_BY_UNKNOWN:
            sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
            $valid = false;
            break;			

        case SITEAPP_DIR_INVALID_NAME:
            sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
            $valid = false;
            break;

        case SITEAPP_DIR_USED_BY_SITEAPP:
            sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
            $valid = false;
            break;
    }


    
	$db_valid = true;

        //check dbname
        $dbname = sapp_get_submit_value('dbname');
        if (!check_dbName($dbname)) {
            sapp_set_wrong('dbname', msg('db__invalid_db_name'));
            $valid = false;
	    $db_valid = false;
        }
        sapp_set_param('dbname', $dbname);
        if ((!$db_valid || !sapp_create_database($dbname, 'mysql')) && $db_valid) {
            sapp_set_wrong('dbname', msg('db__unable_to_create'));
            $valid = false;
        }

	$dbuser_valid = true;
    
	//check dbuser
	$dbuser = sapp_get_submit_value('dbuser');
	if (!check_dbuserName($dbuser)) {
	    sapp_set_wrong('dbuser', msg('db_warning_about_login_syntax'));
	    $valid = false;
	    $dbuser_valid = false;
	}

	sapp_set_param('dbuser', $dbuser);

	$dbpasswd_valid = true;

        //check dbpasswd
        $dbpasswd = sapp_get_submit_value('dbpasswd');
        $dbpasswdconfirm = sapp_get_submit_value('dbpasswdconfirm');
        if ('' == $dbpasswd) {
            if (!sapp_get_param('dbpasswd')) {
                sapp_set_wrong('dbpasswd', msg('password__empty'));
                $valid = false;
                $dbpasswd_valid = false;
            } else {
                $dbpasswd = sapp_get_param('dbpasswd');
            }
	} elseif ($dbpasswd != $dbpasswdconfirm) {
            sapp_set_wrong('dbpasswd', msg('password__not_match'));
            sapp_set_wrong('dbpasswdconfirm', msg('password__not_match'));
            $valid = false;
            $dbpasswd_valid = false;
        } elseif (!check_sys_passwd($dbuser, $dbpasswd)) {
	    sapp_set_wrong('dbpasswd', msg('db_warning_about_passwd_syntax'));
	    $valid = false;
            $dbpasswd_valid = false;
	} else {
	    sapp_set_param('dbpasswd', $dbpasswd);
	}

        if ((!$valid || sapp_is_database_user_exists($dbname, 'mysql', $dbuser, $dbpasswd)) && $dbuser_valid && $db_valid && $dbpasswd_valid) {
	    sapp_set_wrong('dbuser', msg('db__database_user_already_exists'));
	    $valid = false;
	    $dbuser_valid = false;	    
	}
	if ((!$valid || !sapp_create_database_user($dbname, 'mysql', $dbuser, $dbpasswd)) && $dbuser_valid && $db_valid && $dbpasswd_valid) {
	    sapp_set_wrong('dbuser', msg('dbuser__unable_to_create'));
	    $dbuser_valid = false;
	}


	// Check admin_login
	$admin_login = sapp_get_submit_value('admin_login');
        if (!check_sys_login($admin_login)){
            sapp_set_wrong('admin_login', msg('warning_about_login_syntax'));
            $valid = false;
        }
        sapp_set_param('admin_login', $admin_login);

        //check admin password
        $admin_passwd = sapp_get_submit_value('admin_passwd');
        $admin_passwd_confirm = sapp_get_submit_value('admin_passwd_confirm');

        if ('' == $admin_passwd) {
            if (!sapp_get_param('admin_passwd')) {
                sapp_set_wrong('admin_passwd', msg('password__empty'));
                $valid = false;
            } else {
                $admin_passwd = sapp_get_param('admin_passwd');
            }
        } elseif ($admin_passwd != $admin_passwd_confirm) {
            sapp_set_wrong('admin_passwd', msg('password__not_match'));
            sapp_set_wrong('admin_passwd_confirm', msg('password__not_match'));
            $valid = false;
        } elseif (!check_sys_passwd('', $admin_passwd)) {
            sapp_set_wrong('admin_passwd', msg('warning_about_passwd_syntax'));
            $valid = false;
        } else {
            sapp_set_param('admin_passwd', ($admin_passwd));
        }



    if (!$valid) {
        sapp_set_error(msg('invalid_values'));
        return 1;
    }

    // set application URL
    $inst_pref = sapp_get_param('install_prefix');
    $start_path = "";
    if(false){
        sapp_set_param('application_url', "cgi-bin/${inst_pref}${start_path}");
    }
    else{
        sapp_set_param('application_url', "${inst_pref}${start_path}");
    }

    return 2;
}
?>
